#pragma once

#ifndef DIALECTRIC_H
#define DIALECTRIC_H

#include "Material.h"
#include <limits>
#include <algorithm>

class Dialectric :
	public Material
{
public:
	Dialectric() : Material{} {
		baseColor = glm::vec3(1.0f);
		type = "dialectric";
		ior = 1.0f;
	}
	Dialectric(glm::vec3 color) : Material{} {
		baseColor = glm::vec3(1.0f);
		type = "dialectric";
		ior = 1.0f;
	}
	Dialectric(glm::vec3 color, float f) : Material{} {
		baseColor = glm::vec3(1.0f);
		type = "dialectric";
		ior = f;
	}

	glm::vec3 refract(glm::vec3 uv, glm::vec3 n, float refRat);
	ray scatter(ray incident, glm::vec3 norm, glm::vec3 pt);
	
private:
	float ior;
	float schlick(float cosi, float reflIx);
};

#endif