#pragma once

#ifndef LAMBERT_H
#define LAMBERT_H

#include "Material.h"
#include <limits>
#include <string>

class Lambert : public Material
{
public:
	Lambert() : Material{} {
		baseColor = glm::vec3(0.0f);
		type = "lambert";
	}
	Lambert(glm::vec3 color) : Material{} {
		baseColor = color;
		type = "lambert";
	}

	ray scatter(ray incident, glm::vec3 norm, glm::vec3 pt);
};

#endif // !LAMBERT_H