#pragma once

#ifndef LIGHT_H
#define LIGHT_H

#include "Shape.h"
//#include "glm::vec3.h"
#include "glm/glm.hpp"
#include "glm/vec3.hpp"
#include "ray.h"

class Light : public Shape
{
public:
	Light() : Shape{} {
		pos = glm::vec3(0);
		baseColor = glm::vec3(1.0f);
		type = "light";
	}
	Light(glm::vec3 position, glm::vec3 color) : Shape() {
		pos = position;
		baseColor = color;
		type = "light";
	}

	glm::vec3 getPos() {
		return pos;
	}
	glm::vec3 getColor() {
		return baseColor;
	}
};

#endif // !LIGHT_H