#pragma once

#ifndef MATERIAL_H
#define MATERIAL_H

#include <vector>
#include <memory>
#include <string>

#include "camera.h"
#include "ray.h"
//#include "glm::vec3.h"
#include "glm/glm.hpp"
#include "glm/vec3.hpp"

class Material
{
public:
	Material() {
		baseColor = glm::vec3(0.0f);
		type = "none";
	}
	Material(glm::vec3 color) {
		baseColor = color;
		type = "none";
	}

	virtual ray scatter(ray incident, glm::vec3 norm, glm::vec3 pt);
	virtual glm::vec3 getRGB() { return baseColor; }
	virtual std::string getType() { return type; }

protected:
	glm::vec3 baseColor;
	std::string type;
};

#endif // !MATERIAL_H