#pragma once

#ifndef PLANE_H
#define PLANE_H

#include "Shape.h"
#include "Light.h"
#include "camera.h"

class Plane : public Shape
{
public:
	Plane() : Shape{} {
		norm = glm::vec3(0, 1, 0);
		mag = 0;
	}
	Plane(glm::vec3 n, glm::vec3 col, float m) : Shape{} {
		norm = glm::normalize(n);
		baseColor = col;
		mag = m;
		mat = make_shared<Lambert>();
	}
	Plane(glm::vec3 n, glm::vec3 col, float mg, shared_ptr<Material> m) : Shape{} {
		norm = glm::normalize(n);
		baseColor = col;
		mag = mg;
		mat = m;
	}

	virtual float hit(ray& r);
	virtual string getType() {
		return type;
	}
	virtual glm::vec3 getNorm(glm::vec3& pt) {
		return norm;
	}
	glm::vec3 getNormSp(ray& r) {
		return norm;
	}
private:
	string type = "plane";
	glm::vec3 norm;
	float mag;
};

#endif // !PLANE_H