#include <limits>
#include <algorithm>

#include "Rectangle.h"

float Rectangle::hit(ray& r) {
	float t = numeric_limits<float>::max();

	glm::vec3 rayDir = r.getDir();
	glm::vec3 rayPos = r.getPos();

	float invDx = 1.0f / rayDir.x;
	float invDy = 1.0f / rayDir.y;
	float invDz = 1.0f / rayDir.z;

	glm::vec3 min, max;

	min = pos - (dimensions * 0.5f);
	max = pos + (dimensions * 0.5f);

	double tx1 = (min.x - rayPos.x) * invDx;
	double tx2 = (max.x - rayPos.x) * invDx;

	double tmin = std::min(tx1, tx2);
	double tmax = std::max(tx1, tx2);

	double ty1 = (min.y - rayPos.y) * invDy;
	double ty2 = (max.y - rayPos.y) * invDy;

	tmin = std::max(tmin, std::min(ty1, ty2));
	tmax = std::min(tmax, std::max(ty1, ty2));

	double tz1 = (min.z - rayPos.z) * invDz;
	double tz2 = (max.z - rayPos.z) * invDz;

	tmin = std::max(tmin, std::min(tz1, tz2));
	tmax = std::min(tmax, std::max(tz1, tz2));

	if (tmin > tmax || tmin < 0)
		return t;

	return tmin;
}