#pragma once

#ifndef RECTANGLE_H
#define RECTANGLE_H

#include "Shape.h"
class Rectangle : public Shape
{
public:
	Rectangle() : Shape{} {
		norm = glm::vec3(0, 1, 0);
		//dist = 0;
		baseColor = glm::vec3(0.5f);
		width = 1.0f;
		height = 1.0f;
		mat = make_shared<Lambert>();
	}
	Rectangle(glm::vec3 p, glm::vec3 rgb, float w, float h) : Shape{} {
		//dist = p.leng();
		p = glm::normalize(p);
		norm = p;
		baseColor = rgb;
		width = w;
		height = h;
		mat = make_shared<Lambert>();
	}
	Rectangle(glm::vec3 p, glm::vec3 rgb, glm::vec3 dims, shared_ptr<Material> m) : Shape{} {
		pos = p;
		dimensions = dims;
		if (dims.x == 0)
			norm = glm::vec3(1, 0, 0);
		else if (dims.y == 0)
			norm = glm::vec3(0, 1, 0);
		else
			norm = glm::vec3(0, 0, 1);
		//dist = p.leng();
		//p.normalize();
		//norm = p * -1.0f;
		baseColor = rgb;
		//width = w;
		//height = h;
		mat = m;
	}

	virtual float hit(ray& r);
	virtual string getType() {
		return type;
	}
	virtual float getWidth() {
		return width;
	}
	virtual float getHeight() {
		return height;
	}
	virtual glm::vec3 getNorm(glm::vec3& pt) {
		return norm;
	}
	glm::vec3 getNormSp(ray& r) {
		return norm;
	}
private:
	string type = "rectangle";
	float width, height;
	glm::vec3 dimensions;
	//float dist;
	glm::vec3 norm;
};

#endif