#include "Specular.h"

ray Specular::scatter(ray incident, glm::vec3 norm, glm::vec3 pt) {
	//norm.normalize();
	norm = glm::normalize(norm);
	//incident.getDir().normalize();
	glm::vec3 iDir = glm::normalize(incident.getDir());

	//generate random point, test if in unit sphere on surface
	bool inSphere = false;
	float x = 0.0f;
	float y = 0.0f;
	float z = 0.0f;

	while (!inSphere) {
		x = ((float)rand() / RAND_MAX) * 2.0f - 1.0f;
		y = ((float)rand() / RAND_MAX) * 2.0f - 1.0f;
		z = ((float)rand() / RAND_MAX) * 2.0f - 1.0f;
		if (pow(x, 2) + pow(y, 2) + pow(z, 2) <= 1)
			inSphere = true;
	}

	x *= fuzz;
	y *= fuzz;
	z *= fuzz;

	//glm::vec3 d = (incident.getDir() - (norm * 2 * (iDir.dot(norm))));
	glm::vec3 d = (iDir - (norm * 2.0f * (glm::dot(iDir, norm))));

	x += d.x;
	y += d.y;
	z += d.z;

	//glm::vec3 dir = glm::vec3(x - pt.x(), y - pt.y(), z - pt.z());
	glm::vec3 dir = glm::vec3(x, y, z);
	ray retRay = ray(pt, dir);
	//cout << "what" << endl;
	return retRay;
}