#pragma once

#ifndef SPECULAR_H
#define SPECULAR_H

#include "Material.h"
#include <limits>

class Specular : public Material
{
public:
	Specular() : Material{} {
		baseColor = glm::vec3(0.0f);
		type = "specular";
		fuzz = 1.0f;
	}
	Specular(glm::vec3 color) : Material{} {
		baseColor = color;
		type = "specular";
		fuzz = 1.0f;
	}
	Specular(glm::vec3 color, float f) : Material{} {
		baseColor = color;
		type = "specular";
		fuzz = f;
	}

	ray scatter(ray incident, glm::vec3 norm, glm::vec3 pt);
private:
	float fuzz;
};

#endif