#ifndef ASCII_H
#define ASCII_H

#include <ostream>
#include "raster.h"

using namespace std;

class asciiR : public raster {

	public:
		asciiR(const implicit inF) : raster{inF} {}

		asciiR(int w, int h, const implicit inF) : raster{inF} { 
			width = w; 
			height = h; 
      }
	
	virtual void writeOut(ostream& out) const override;

	public:
   	char inside = '-';
		char outside = 'o';
};

void asciiR::writeOut(ostream& out) const {

	float res;

	for (int y=0; y < height; y++) {
		for (int x =0; x < width; x++) {
			res = fn.eval(x, y);
			if (res < 0)			
				out << inside << " ";
			else
				out << outside << " ";
		}
		out << "\n";
	}
}
#endif
