#ifndef CAMERA_H
#define CAMERA_H

//#include "vec3.h"
#include "glm/glm.hpp"
#include "glm/vec3.hpp"

class camera {
public:
	camera() {
		eye = glm::vec3(0.0f, 0.0f, 5.0f);
		right = glm::vec3(1.0f, 0.0f, 0.0f);
		up = glm::vec3(0.0f, 1.0f, 0.0f);
		lookAt = glm::vec3(0.0f);
	}
	camera(glm::vec3 e, glm::vec3 r, glm::vec3 u, glm::vec3 LA) {
		eye = e;
		right = r;
		up = u;
		lookAt = LA;
	}
	camera(glm::vec3 e, glm::vec3 LA) {
		eye = e;
		lookAt = LA;
		up = glm::vec3(0.0f, 1.0f, 0.0f);
		calcRight();
	}

	glm::vec3 getEye() {
		return eye;
	}
	
	glm::vec3 getRight() {
		return right;
	}

	glm::vec3 getUp() {
		return up;
	}

	glm::vec3 getLA() {
		return lookAt;
	}

	void setEye(glm::vec3 e) {
		eye = e;
		calcRight();
	}

	void setLA(glm::vec3 LA) {
		lookAt = LA;
		calcRight();
	}

	void setUp(glm::vec3 u) {
		up = u;
		calcRight();
	}

	void calcRight() {
		glm::vec3 eye2LA = lookAt - eye;
		//eye2LA.normalize();
		eye2LA = glm::normalize(eye2LA);
		right = glm::cross(eye2LA, up);//eye2LA.cross(up);
	}

private:
	glm::vec3 eye, right, up, lookAt;
};

#endif // !CAMERA_H
