#ifndef PPM_H
#define PPM_H

#include <ostream>
#include <string>
#include <algorithm>
//#include "vec3.h"
#include "glm/glm.hpp"
#include "glm/vec3.hpp"
#include "raster.h"

using namespace std;

//rasterize into ppm format
class ppm : public raster {

public:
	ppm(const implicit inF) : raster{ inF } {}

	ppm(int w, int h, const implicit inF) : raster{ inF } {
		width = w;
		height = h;
	}

	ppm(int w, int h, glm::vec3 pix[]) {
		width = w;
		height = h;
		pixels = pix;
	}

	virtual void writeOut(ostream& out) const override;
	//void writeHeader(ostream& out) override;
public:
	char inside = '-';
	char outside = 'o';
	glm::vec3 *pixels;

	glm::vec3 inCol = glm::vec3(143, 94, 0);		//dark gold
	glm::vec3 outCol = glm::vec3(0, 28, 67);		//cobalt blue
};

//render
void ppm::writeOut(ostream& out) const {

	out << "P3\n";
	out << width << " " << height << "\n255\n";

	//for (int y = 0; y < height; y++) {
	for(int y = height-1; y >= 0; y--){
		for (int x = 0; x < width; x++) {
			string ret = to_string((int)(pixels[y * width + x].x * 255.0f)) + " " + to_string((int)(pixels[y * width + x].y * 255.0f)) + " " + to_string((int)(pixels[y * width + x].z * 255.0f)) + " ";
			out << ret;
		}
		out << "\n";
	}
}
#endif
