#pragma once

#ifndef RAY_H
#define RAY_H

//#include "vec3.h"
#include "glm/glm.hpp"
#include "glm/vec3.hpp"

class ray
{
public:
	ray() {
		pos = glm::vec3(0.0f);
		dir = glm::vec3(0.0f, 0.0f, -1.0f);
		mag = 1.0f;
	}
	ray(glm::vec3 p, glm::vec3 d) {
		pos = p;
		dir = glm::normalize(d);
		//dir.normalize();
		mag = glm::length(dir);
	}

	glm::vec3 getPos() {
		return pos;
	}

	glm::vec3 getDir() {
		return dir;
	}

	float getMag() {
		return mag;
	}

	glm::vec3 rayAt(float t) {
		glm::vec3 step = pos + (dir * t);
		return step;
	}

private:
	glm::vec3 pos, dir;
	float mag;
};

#endif